Index: src/com/metamatrix/modeler/transformation/aspects/validation/rules/SqlTransformationMappingRootValidationRule.java
===================================================================
--- src/com/metamatrix/modeler/transformation/aspects/validation/rules/SqlTransformationMappingRootValidationRule.java	(revision 1029)
+++ src/com/metamatrix/modeler/transformation/aspects/validation/rules/SqlTransformationMappingRootValidationRule.java	(working copy)
@@ -21,6 +21,26 @@
 import org.eclipse.emf.mapping.Mapping;
 import org.eclipse.emf.mapping.MappingRoot;
 import org.teiid.core.types.DataTypeManager;
+import org.teiid.query.function.FunctionLibrary;
+import org.teiid.query.sql.LanguageObject;
+import org.teiid.query.sql.lang.AbstractCompareCriteria;
+import org.teiid.query.sql.lang.Command;
+import org.teiid.query.sql.lang.CompareCriteria;
+import org.teiid.query.sql.lang.Option;
+import org.teiid.query.sql.lang.Query;
+import org.teiid.query.sql.navigator.DeepPreOrderNavigator;
+import org.teiid.query.sql.proc.CreateUpdateProcedureCommand;
+import org.teiid.query.sql.proc.HasCriteria;
+import org.teiid.query.sql.proc.TranslateCriteria;
+import org.teiid.query.sql.symbol.ElementSymbol;
+import org.teiid.query.sql.symbol.Expression;
+import org.teiid.query.sql.symbol.Function;
+import org.teiid.query.sql.symbol.GroupSymbol;
+import org.teiid.query.sql.visitor.CommandCollectorVisitor;
+import org.teiid.query.sql.visitor.ElementCollectorVisitor;
+import org.teiid.query.sql.visitor.FunctionCollectorVisitor;
+import org.teiid.query.sql.visitor.GroupCollectorVisitor;
+import org.teiid.query.sql.visitor.PredicateCollectorVisitor;
 import com.metamatrix.core.util.CoreArgCheck;
 import com.metamatrix.core.util.CoreStringUtil;
 import com.metamatrix.metamodels.core.ModelAnnotation;
@@ -68,26 +88,6 @@
 import com.metamatrix.modeler.transformation.validation.SqlTransformationResult;
 import com.metamatrix.modeler.transformation.validation.TransformationValidationResult;
 import com.metamatrix.modeler.transformation.validation.TransformationValidator;
-import org.teiid.query.function.FunctionLibrary;
-import org.teiid.query.sql.LanguageObject;
-import org.teiid.query.sql.lang.AbstractCompareCriteria;
-import org.teiid.query.sql.lang.Command;
-import org.teiid.query.sql.lang.CompareCriteria;
-import org.teiid.query.sql.lang.Option;
-import org.teiid.query.sql.lang.Query;
-import org.teiid.query.sql.navigator.DeepPreOrderNavigator;
-import org.teiid.query.sql.proc.CreateUpdateProcedureCommand;
-import org.teiid.query.sql.proc.HasCriteria;
-import org.teiid.query.sql.proc.TranslateCriteria;
-import org.teiid.query.sql.symbol.ElementSymbol;
-import org.teiid.query.sql.symbol.Expression;
-import org.teiid.query.sql.symbol.Function;
-import org.teiid.query.sql.symbol.GroupSymbol;
-import org.teiid.query.sql.visitor.CommandCollectorVisitor;
-import org.teiid.query.sql.visitor.ElementCollectorVisitor;
-import org.teiid.query.sql.visitor.FunctionCollectorVisitor;
-import org.teiid.query.sql.visitor.GroupCollectorVisitor;
-import org.teiid.query.sql.visitor.PredicateCollectorVisitor;
 
 /**
  * SqlTransformationMappingRootValidationRule
@@ -670,7 +670,8 @@
             boolean updatable = false;
             for (final Iterator inIter = inputs.iterator(); inIter.hasNext();) {
                 EObject sourceObj = (EObject)inIter.next();
-                if (com.metamatrix.modeler.core.metamodel.aspect.sql.SqlAspectHelper.isUpdatableGroup(sourceObj)) {
+                if (com.metamatrix.modeler.core.metamodel.aspect.sql.SqlAspectHelper.isUpdatableGroup(sourceObj)
+                    || com.metamatrix.modeler.core.metamodel.aspect.sql.SqlAspectHelper.isProcedure(sourceObj)) {
                     updatable = true;
                     break;
                 }
@@ -679,7 +680,7 @@
             if (!updatable) {
                 ValidationProblem problem = new ValidationProblemImpl(
                                                                       0,
-                                                                      IStatus.ERROR,
+                                                                      IStatus.WARNING,
                                                                       TransformationPlugin.Util.getString("SqlTransformationMappingRootValidationRule.The_transformation_defining_an_updatable_virtual_group_should_be_include_atleast_one_updatable_source_group._1", TransformationHelper.getSqlEObjectName(targetObj))); //$NON-NLS-1$
                 validationResult.addProblem(problem);
             }