Index: ewp-config/scripts/rename-props.sh
===================================================================
--- ewp-config/scripts/rename-props.sh	(revision 1575)
+++ ewp-config/scripts/rename-props.sh	(working copy)
@@ -15,6 +15,7 @@
 cd ${INSTALL_PATH}/jboss-as-web/server/default/conf/props/
 mv jmx-console-roles.properties $domain-roles.properties
 mv jmx-console-users.properties $domain-users.properties
+
 echo "Renaming Production Profile..."
 cd ${INSTALL_PATH}/jboss-as-web/server/production/conf/props/
 mv jmx-console-roles.properties $domain-roles.properties
Index: ewp-config/scripts/ant-secdom.xml
===================================================================
--- ewp-config/scripts/ant-secdom.xml	(revision 1575)
+++ ewp-config/scripts/ant-secdom.xml	(working copy)
@@ -1,15 +0,0 @@
-<?xml version="1.0"?>
-
-<!-- Define reference to file containing common targets -->
-<project name="secdom" default="rename"
-         basedir="${INSTALL_PATH}/jboss-as-web">
-         
-     <target name="rename">
-        <echo>Changing property file names</echo>
-     		<exec executable="${INSTALL_PATH}/jboss-as-web/scripts/rename-props.sh">
-     			<arg value="${INSTALL_PATH}"/>
-     			<arg value="${jmxConsoleDomain}"/>
-       		</exec>
-     </target>
-    	
-</project>
\ No newline at end of file
Index: ewp-config/scripts/secdom-unix.xml
===================================================================
--- ewp-config/scripts/secdom-unix.xml	(revision 0)
+++ ewp-config/scripts/secdom-unix.xml	(revision 0)
@@ -0,0 +1,15 @@
+<?xml version="1.0"?>
+
+<!-- Define reference to file containing common targets -->
+<project name="secdom" default="rename"
+         basedir="${INSTALL_PATH}/jboss-as">
+         
+     <target name="rename">
+        <echo>Changing property file names</echo>
+     		<exec executable="${INSTALL_PATH}/jboss-as/scripts/rename-props.sh">
+     			<arg value="${INSTALL_PATH}"/>
+     			<arg value="${jmxConsoleDomain}"/>
+       		</exec>
+     </target>
+    	
+</project>
\ No newline at end of file
Index: ewp-config/scripts/secdom-win.xml
===================================================================
--- ewp-config/scripts/secdom-win.xml	(revision 0)
+++ ewp-config/scripts/secdom-win.xml	(revision 0)
@@ -0,0 +1,15 @@
+<?xml version="1.0"?>
+
+<!-- Define reference to file containing common targets -->
+<project name="secdom" default="rename"
+         basedir="${INSTALL_PATH}/jboss-as">
+         
+     <target name="rename">
+        <echo>Changing property file names</echo>
+     		<exec executable="${INSTALL_PATH}/jboss-as/scripts/rename-props.bat">
+     			<arg value="${INSTALL_PATH}"/>
+     			<arg value="${jmxConsoleDomain}"/>
+       		</exec>
+     </target>
+    	
+</project>
\ No newline at end of file
Index: ewp-config/scripts/rename-props.bat
===================================================================
--- ewp-config/scripts/rename-props.bat	(revision 0)
+++ ewp-config/scripts/rename-props.bat	(revision 0)
@@ -0,0 +1,24 @@
+@echo off
+set INSTALL_PATH=%1
+set domain=%2
+
+if [%domain%] == [jmx-console] (
+	echo No custom security domain set. Exiting
+	exit \b
+)
+
+echo Install path is %INSTALL_PATH%.
+echo Renaming with %domain% domain. 
+
+echo Renaming Default Profile...
+cd %INSTALL_PATH%\jboss-as\server\default\conf\props
+ren jmx-console-roles.properties %domain%-roles.properties
+ren jmx-console-users.properties %domain%-users.properties
+
+echo Renaming Production Profile...
+cd %INSTALL_PATH%\jboss-as\server\production\conf\props
+ren jmx-console-roles.properties %domain%-roles.properties
+ren jmx-console-users.properties %domain%-users.properties
+
+
+
Index: ewp-config/antActionsSpec.xml
===================================================================
--- ewp-config/antActionsSpec.xml	(revision 1575)
+++ ewp-config/antActionsSpec.xml	(working copy)
@@ -30,15 +30,28 @@
        <property name="INSTALL_PATH" value="${INSTALL_PATH}/${jboss.dist.dir}"/>
        <target name="chmod-bin"/>
     </antcall>
-   
-    <!-- Make conf/props filenames correct for changed JAAS security domains -->   
-    <antcall order="afterpacks" buildfile="${INSTALL_PATH}/${jboss.dist.dir}/jboss-as-web/scripts/ant-secdom.xml" verbose="false">
+  </pack>
+    
+  <!-- Change the JAAS domain for unix -->
+  <pack name="JBoss Shell Scripts">
+      <!-- Make conf/props filenames correct for changed JAAS security domains -->   
+    <antcall order="afterpacks" buildfile="${INSTALL_PATH}/${jboss.dist.dir}/jboss-as-web/scripts/secdom-unix.xml" verbose="false">
   	 	<property name="INSTALL_PATH" value="${INSTALL_PATH}/${jboss.dist.dir}"/>
     	<property name="jmxConsoleDomain" value="${jmxConsoleDomain}"/>
  	   	<target name="rename"/> 
     </antcall>
   </pack>
-    
+  
+  <!-- Change JAAS domain for windows -->  
+  <pack name="JBoss Batch Scripts">
+    <antcall order="afterpacks" buildfile="${INSTALL_PATH}/${jboss.dist.dir}/jboss-as-web/scripts/secdom-win.xml" verbose="false">
+  		<property name="INSTALL_PATH" value="${INSTALL_PATH}/${jboss.dist.dir}"/>
+  		<property name="jmxConsoleDomain" value="${jmxConsoleDomain}"/>
+  		<target name="rename"/>
+  	</antcall>
+  </pack>
+  
+  
     <!-- Replace WSNative with WSCXF -->
   <pack name="jbossws-cxf">
        <antcall order="afterpacks" buildfile="${INSTALL_PATH}/${jboss.dist.dir}/jboss-as-web/scripts/install-cxf.xml" verbose="false" inheritall="false">    
Index: eap-config/scripts/rename-props.sh
===================================================================
--- eap-config/scripts/rename-props.sh	(revision 1575)
+++ eap-config/scripts/rename-props.sh	(working copy)
@@ -15,18 +15,22 @@
 cd ${INSTALL_PATH}/jboss-as/server/all/conf/props/
 mv jmx-console-roles.properties $domain-roles.properties
 mv jmx-console-users.properties $domain-users.properties
+
 echo "Renaming Default Profile..."
 cd ${INSTALL_PATH}/jboss-as/server/default/conf/props/
 mv jmx-console-roles.properties $domain-roles.properties
 mv jmx-console-users.properties $domain-users.properties
+
 echo "Renaming Production Profile..."
 cd ${INSTALL_PATH}/jboss-as/server/production/conf/props/
 mv jmx-console-roles.properties $domain-roles.properties
 mv jmx-console-users.properties $domain-users.properties
+
 echo "Renaming Standard Profile..."
 cd ${INSTALL_PATH}/jboss-as/server/standard/conf/props/
 mv jmx-console-roles.properties $domain-roles.properties
 mv jmx-console-users.properties $domain-users.properties
+
 echo "Renaming Web Profile..."
 cd ${INSTALL_PATH}/jboss-as/server/web/conf/props/
 mv jmx-console-roles.properties $domain-roles.properties
Index: eap-config/scripts/ant-secdom.xml
===================================================================
--- eap-config/scripts/ant-secdom.xml	(revision 1575)
+++ eap-config/scripts/ant-secdom.xml	(working copy)
@@ -1,15 +0,0 @@
-<?xml version="1.0"?>
-
-<!-- Define reference to file containing common targets -->
-<project name="secdom" default="rename"
-         basedir="${INSTALL_PATH}/jboss-as">
-         
-     <target name="rename">
-        <echo>Changing property file names</echo>
-     		<exec executable="${INSTALL_PATH}/jboss-as/scripts/rename-props.sh">
-     			<arg value="${INSTALL_PATH}"/>
-     			<arg value="${jmxConsoleDomain}"/>
-       		</exec>
-     </target>
-    	
-</project>
\ No newline at end of file
Index: eap-config/scripts/rename-props.bat
===================================================================
--- eap-config/scripts/rename-props.bat	(revision 1575)
+++ eap-config/scripts/rename-props.bat	(working copy)
@@ -2,30 +2,37 @@
 set INSTALL_PATH=%1
 set domain=%2
 
-if "%domain%" == "jmx-console"(
+if [%domain%] == [jmx-console] (
 	echo No custom security domain set. Exiting
+	exit \b
 )
 
 echo Install path is %INSTALL_PATH%.
-echo Renaming with %domain%. 
+echo Renaming with %domain% domain. 
 
 echo Renaming All Profile...
-cd %INSTALL_PATH%\jboss-as\server\all\conf\props\
+cd %INSTALL_PATH%\jboss-as\server\all\conf\props
 ren jmx-console-roles.properties %domain%-roles.properties
 ren jmx-console-users.properties %domain%-users.properties
+
 echo Renaming Default Profile...
-cd %INSTALL_PATH%\jboss-as\server\default\conf\props\
+cd %INSTALL_PATH%\jboss-as\server\default\conf\props
 ren jmx-console-roles.properties %domain%-roles.properties
 ren jmx-console-users.properties %domain%-users.properties
+
 echo Renaming Production Profile...
-cd %INSTALL_PATH%\jboss-as\server\production\conf\props\
+cd %INSTALL_PATH%\jboss-as\server\production\conf\props
 ren jmx-console-roles.properties %domain%-roles.properties
 ren jmx-console-users.properties %domain%-users.properties
+
 echo Renaming Standard Profile...
-cd %INSTALL_PATH%\jboss-as\server\standard\conf\props\
+cd %INSTALL_PATH%\jboss-as\server\standard\conf\props
 ren jmx-console-roles.properties %domain%-roles.properties
 ren jmx-console-users.properties %domain%-users.properties
+
 echo Renaming Web Profile...
-cd %INSTALL_PATH%\jboss-as\server\web\conf\props\
+cd %INSTALL_PATH%\jboss-as\server\web\conf\props
 ren jmx-console-roles.properties %domain%-roles.properties
 ren jmx-console-users.properties %domain%-users.properties
+
+
Index: eap-config/antActionsSpec.xml
===================================================================
--- eap-config/antActionsSpec.xml	(revision 1575)
+++ eap-config/antActionsSpec.xml	(working copy)
@@ -30,7 +30,7 @@
   </pack>
   
   <!-- Make conf/props filenames correct for changed JAAS security domains (unix) -->
-  <pack name="jboss-shell">   
+  <pack name="JBossAS Shell Scripts">   
   	<antcall order="afterpacks" buildfile="${INSTALL_PATH}/${jboss.dist.dir}/jboss-as/scripts/secdom-unix.xml" verbose="false">
   		<property name="INSTALL_PATH" value="${INSTALL_PATH}/${jboss.dist.dir}"/>
   		<property name="jmxConsoleDomain" value="${jmxConsoleDomain}"/>
@@ -39,7 +39,7 @@
   </pack>
   
   <!-- make conf/props filenames correct for changed JAAS security domains (windows) -->
-  <pack id="jboss-batch">   
+  <pack name="JBossAS Batch Scripts">   
   	<antcall order="afterpacks" buildfile="${INSTALL_PATH}/${jboss.dist.dir}/jboss-as/scripts/secdom-win.xml" verbose="false">
   		<property name="INSTALL_PATH" value="${INSTALL_PATH}/${jboss.dist.dir}"/>
   		<property name="jmxConsoleDomain" value="${jmxConsoleDomain}"/>