Index: META-INF/MANIFEST.MF
===================================================================
--- META-INF/MANIFEST.MF	(revision 27016)
+++ META-INF/MANIFEST.MF	(working copy)
@@ -23,6 +23,5 @@
 Bundle-Activator: org.jboss.tools.usage.internal.JBossToolsUsageActivator
 Bundle-Vendor: %bundle-vendor
 Bundle-ActivationPolicy: lazy
-Import-Package: org.jboss.tools.common.log
 
 
Index: src/org/jboss/tools/usage/http/HttpGetRequest.java
===================================================================
--- src/org/jboss/tools/usage/http/HttpGetRequest.java	(revision 27016)
+++ src/org/jboss/tools/usage/http/HttpGetRequest.java	(working copy)
@@ -15,7 +15,7 @@
 import java.net.URL;
 import java.text.MessageFormat;
 
-import org.jboss.tools.common.log.ILoggingAdapter;
+import org.jboss.tools.usage.tracker.internal.UsagePluginLogger;
 
 /**
  * Class that executes a HTTP Get request to the given url.
@@ -28,18 +28,13 @@
 
 	private static final String GET_METHOD_NAME = "GET"; //$NON-NLS-1$
 	
-	private ILoggingAdapter loggingAdapter = null;
+	private UsagePluginLogger logger = null;
 
-//	private CookieHandler cookieHandler;
-	
 	private String userAgent;
 
-	public HttpGetRequest(String userAgent, ILoggingAdapter loggingAdapter) {
+	public HttpGetRequest(String userAgent, UsagePluginLogger logger) {
 		this.userAgent = userAgent;
-		this.loggingAdapter = loggingAdapter;
-//		this.cookieHandler = new CookieHandler();
-//		this.cookieHandler = CookieHandler.getDefault();
-//		cookieHandler.setCookiePolicy(CookiePolicy.ACCEPT_ALL);
+		this.logger = logger;
 	}
 
 	/* (non-Javadoc)
@@ -47,20 +42,17 @@
 	 */
 	public void request(String urlString) {
 
-//		CookieHandler currentCookieHandler = setCookieHandler(cookieHandler);
 		try {
 			HttpURLConnection urlConnection = createURLConnection(urlString, userAgent);
 			urlConnection.connect();
 			int responseCode = getResponseCode(urlConnection);
 			if (responseCode == HttpURLConnection.HTTP_OK) {
-				loggingAdapter.debug(MessageFormat.format(HttpMessages.HttpGetMethod_Success, urlString, responseCode));
+				logger.debug(MessageFormat.format(HttpMessages.HttpGetMethod_Success, urlString, responseCode));
 			} else {
-				loggingAdapter.error(MessageFormat.format(HttpMessages.HttpGetMethod_Error_Http, urlString, responseCode));
+				logger.error(MessageFormat.format(HttpMessages.HttpGetMethod_Error_Http, urlString, responseCode));
 			}
 		} catch (Exception e) {
-			loggingAdapter.debug(MessageFormat.format(HttpMessages.HttpGetMethod_Error_Io, urlString, e.toString()));
-		} finally {
-//			setCookieHandler(currentCookieHandler);
+			logger.debug(MessageFormat.format(HttpMessages.HttpGetMethod_Error_Io, urlString, e.toString()));
 		}
 	}
 
@@ -76,12 +68,6 @@
 		return urlConnection.getResponseCode();
 	}
 
-//	private CookieHandler setCookieHandler(CookieHandler cookieHandler) {
-//		CookieHandler currentCookieHandler = CookieHandler.getDefault();
-//		CookieHandler.setDefault(cookieHandler);
-//		return currentCookieHandler;
-//	}
-
 	/**
 	 * Creates a new url connection.
 	 *
Index: src/org/jboss/tools/usage/http/HttpRemotePropertiesProvider.java
===================================================================
--- src/org/jboss/tools/usage/http/HttpRemotePropertiesProvider.java	(revision 27016)
+++ src/org/jboss/tools/usage/http/HttpRemotePropertiesProvider.java	(working copy)
@@ -21,12 +21,8 @@
 import java.util.HashMap;
 import java.util.Map;
 
-import org.eclipse.core.runtime.IStatus;
-import org.eclipse.core.runtime.Plugin;
-import org.jboss.tools.common.log.ILoggingAdapter;
+import org.jboss.tools.usage.tracker.internal.UsagePluginLogger;
 import org.jboss.tools.usage.util.HttpEncodingUtils;
-import org.jboss.tools.usage.util.LoggingUtils;
-import org.jboss.tools.usage.util.StatusUtils;
 import org.jboss.tools.usage.util.reader.ReaderUtils;
 
 
@@ -45,14 +41,13 @@
 	private String[] keys;
 	private String url;
 	private char valueDelimiter;
-	protected Plugin plugin;
-	private ILoggingAdapter loggingAdapter;
+	private UsagePluginLogger logger;
 
-	public HttpRemotePropertiesProvider(String url, char valueDelimiter, ILoggingAdapter loggingAdapter, String... keys) {
+	public HttpRemotePropertiesProvider(String url, char valueDelimiter, UsagePluginLogger loggingAdapter, String... keys) {
 		this.url = url;
 		this.keys = keys;
 		this.valueDelimiter = valueDelimiter;
-		this.loggingAdapter = loggingAdapter;
+		this.logger = loggingAdapter;
 	}
 
 
@@ -86,18 +81,14 @@
 			urlConnection.connect();
 			int responseCode = getResponseCode(urlConnection);
 			if (responseCode == HttpURLConnection.HTTP_OK) {
-				IStatus status = StatusUtils.getInfoStatus(
-						plugin.getBundle().getSymbolicName()
-						, HttpMessages.HttpResourceMap_Info_HttpQuery
-						, url);
-				LoggingUtils.log(status, plugin);
+				logger.debug(MessageFormat.format(HttpMessages.HttpResourceMap_Info_HttpQuery, url));
 				responseReader = getInputStreamReader(urlConnection.getInputStream(), urlConnection.getContentType());
 			} else {
-				loggingAdapter.error(MessageFormat.format(HttpMessages.HttpGetMethod_Error_Http, url, responseCode));
+				logger.error(MessageFormat.format(HttpMessages.HttpGetMethod_Error_Http, url, responseCode));
 			}
 			return responseReader;
 		} catch (IOException e) {
-			loggingAdapter.debug(MessageFormat.format(HttpMessages.HttpGetMethod_Error_Io, url, e.toString()));
+			logger.debug(MessageFormat.format(HttpMessages.HttpGetMethod_Error_Io, url, e.toString()));
 			throw e;
 		}
 	}
Index: src/org/jboss/tools/usage/internal/reporting/UsageReport.java
===================================================================
--- src/org/jboss/tools/usage/internal/reporting/UsageReport.java	(revision 27016)
+++ src/org/jboss/tools/usage/internal/reporting/UsageReport.java	(working copy)
@@ -19,7 +19,6 @@
 import org.eclipse.jface.window.Window;
 import org.eclipse.ui.PlatformUI;
 import org.eclipse.ui.progress.UIJob;
-import org.jboss.tools.common.log.ILoggingAdapter;
 import org.jboss.tools.usage.googleanalytics.GoogleAnalyticsUrlStrategy;
 import org.jboss.tools.usage.googleanalytics.IJBossToolsEclipseEnvironment;
 import org.jboss.tools.usage.http.HttpGetRequest;
@@ -33,7 +32,6 @@
 import org.jboss.tools.usage.tracker.internal.SuffixFocusPoint;
 import org.jboss.tools.usage.tracker.internal.Tracker;
 import org.jboss.tools.usage.tracker.internal.UsagePluginLogger;
-import org.jboss.tools.usage.util.StatusUtils;
 import org.osgi.framework.InvalidSyntaxException;
 import org.osgi.service.prefs.BackingStoreException;
 
@@ -48,13 +46,14 @@
 
 	private IJBossToolsEclipseEnvironment eclipseEnvironment;
 
+	UsagePluginLogger logger = new UsagePluginLogger(JBossToolsUsageActivator.getDefault());
+	
 	public UsageReport() throws InvalidSyntaxException {
 		eclipseEnvironment = JBossToolsUsageActivator.getDefault().getJBossToolsEclipseEnvironment();
 		focusPoint = new SuffixFocusPoint("tools", eclipseEnvironment.getJBossToolsVersion()) //$NON-NLS-1$ 
 				.setChild(new FocusPoint("usage") //$NON-NLS-1$ 
 						.setChild(new FocusPoint("action") //$NON-NLS-1$ 
 								.setChild(new FocusPoint("wsstartup")))); //$NON-NLS-1$
-
 		globalSettings = new GlobalUsageSettings(JBossToolsUsageActivator
 				.getDefault());
 	}
@@ -78,9 +77,7 @@
 		try {
 			UsageReportPreferences.flush();
 		} catch (BackingStoreException e) {
-			IStatus status = StatusUtils.getErrorStatus(JBossToolsUsageActivator.PLUGIN_ID,
-					ReportingMessages.UsageReport_Error_SavePreferences, e);
-			JBossToolsUsageActivator.getDefault().getLog().log(status);
+			logger.error(ReportingMessages.UsageReport_Error_SavePreferences);
 		}
 	}
 
@@ -91,11 +88,10 @@
 	private void doReport() {
 		if (UsageReportPreferences.isEnabled()) {
 			IURLBuildingStrategy urlBuildingStrategy = new GoogleAnalyticsUrlStrategy(eclipseEnvironment);
-			ILoggingAdapter loggingAdapter = new UsagePluginLogger(JBossToolsUsageActivator.getDefault());
 			ITracker tracker = new Tracker(
 					urlBuildingStrategy
-					, new HttpGetRequest(eclipseEnvironment.getUserAgent(), loggingAdapter)
-					, loggingAdapter);
+					, new HttpGetRequest(eclipseEnvironment.getUserAgent(), logger)
+					, logger);
 			tracker.trackAsynchronously(focusPoint);
 		}
 	}
Index: src/org/jboss/tools/usage/internal/reporting/UsageReportDispatcher.java
===================================================================
--- src/org/jboss/tools/usage/internal/reporting/UsageReportDispatcher.java	(revision 27016)
+++ src/org/jboss/tools/usage/internal/reporting/UsageReportDispatcher.java	(working copy)
@@ -10,12 +10,10 @@
  ******************************************************************************/
 package org.jboss.tools.usage.internal.reporting;
 
-import org.eclipse.core.runtime.IStatus;
 import org.eclipse.swt.widgets.Display;
 import org.eclipse.ui.IStartup;
 import org.jboss.tools.usage.internal.JBossToolsUsageActivator;
-import org.jboss.tools.usage.util.LoggingUtils;
-import org.jboss.tools.usage.util.StatusUtils;
+import org.jboss.tools.usage.tracker.internal.UsagePluginLogger;
 
 /**
  * @author Andre Dieitsheim
@@ -29,8 +27,7 @@
 				try {
 					new UsageReport().report();
 				} catch (Exception e) {
-					IStatus status = StatusUtils.getErrorStatus(JBossToolsUsageActivator.PLUGIN_ID, "could not start usage reporting", e);
-					LoggingUtils.log(status, JBossToolsUsageActivator.getDefault());
+					new UsagePluginLogger(JBossToolsUsageActivator.getDefault()).error("could not start usage reporting");
 				}
 			}
 		});
Index: src/org/jboss/tools/usage/internal/preferences/UsageReportPreferences.java
===================================================================
--- src/org/jboss/tools/usage/internal/preferences/UsageReportPreferences.java	(revision 27016)
+++ src/org/jboss/tools/usage/internal/preferences/UsageReportPreferences.java	(working copy)
@@ -10,11 +10,12 @@
  ******************************************************************************/
 package org.jboss.tools.usage.internal.preferences;
 
-import org.eclipse.core.runtime.preferences.IEclipsePreferences;
+import java.io.IOException;
+
 import org.eclipse.jface.preference.IPreferenceStore;
 import org.jboss.tools.usage.internal.JBossToolsUsageActivator;
 import org.jboss.tools.usage.internal.reporting.ReportingMessages;
-import org.jboss.tools.usage.util.StatusUtils;
+import org.jboss.tools.usage.tracker.internal.UsagePluginLogger;
 import org.osgi.service.prefs.BackingStoreException;
 
 /**
@@ -24,7 +25,8 @@
 
 	public static void setEnabled(boolean enabled) {
 		UsageReportPreferencesUtils.getStore().putValue(
-				IUsageReportPreferenceConstants.USAGEREPORT_ENABLED_ID, String.valueOf(enabled));
+					IUsageReportPreferenceConstants.USAGEREPORT_ENABLED_ID, String.valueOf(enabled));
+		save();
 	}
 
 	public static boolean isEnabled() {
@@ -35,21 +37,24 @@
 
 	public static boolean isAskUser() {
 		return UsageReportPreferencesUtils.getPreferences().getBoolean(
-				IUsageReportPreferenceConstants.ASK_USER_USAGEREPORT_ID, 
+				IUsageReportPreferenceConstants.ASK_USER_USAGEREPORT_ID,
 				IUsageReportPreferenceConstants.ASK_USER_USAGEREPORT_DEFAULTVALUE);
 	}
 
 	public static void setAskUser(boolean askUser) {
+		UsageReportPreferencesUtils.getStore().putValue(IUsageReportPreferenceConstants.ASK_USER_USAGEREPORT_ID,
+				String.valueOf(askUser));
+		save();
+	}
+
+	private static void save() {
 		try {
-			IEclipsePreferences preferences = UsageReportPreferencesUtils.getPreferences();
-			preferences.putBoolean(IUsageReportPreferenceConstants.ASK_USER_USAGEREPORT_ID, askUser);
-			preferences.flush();
-		} catch (BackingStoreException e) {
-			JBossToolsUsageActivator.getDefault().getLog().log(
-					StatusUtils.getErrorStatus(JBossToolsUsageActivator.PLUGIN_ID,
-							ReportingMessages.UsageReport_Error_SavePreferences, e,
-							IUsageReportPreferenceConstants.ASK_USER_USAGEREPORT_ID));
+			UsageReportPreferencesUtils.getStore().save();
+		} catch (IOException e) {
+			new UsagePluginLogger(JBossToolsUsageActivator.getDefault()).error(
+							ReportingMessages.UsageReport_Error_SavePreferences);
 		}
+
 	}
 
 	public static void flush() throws BackingStoreException {
Index: src/org/jboss/tools/usage/internal/preferences/GlobalUsageSettings.java
===================================================================
--- src/org/jboss/tools/usage/internal/preferences/GlobalUsageSettings.java	(revision 27016)
+++ src/org/jboss/tools/usage/internal/preferences/GlobalUsageSettings.java	(working copy)
@@ -32,8 +32,12 @@
 	 * system property that enables/disables reporting for current eclipse
 	 * instance
 	 */
-	public static final String USAGE_REPORTING_ENABLED_KEY = "usage_reporting_enabled";
+	public static final String USAGE_REPORTING_ENABLED_KEY = "usage_reporting_enabled"; //$NON-NLS-1$
 
+	/**
+	 * system property that enables/disables reporting for all eclipse
+	 * instances
+	 */
 	public static final String REMOTEPROPS_USAGE_REPORTING_ENABLED_KEY = USAGE_REPORTING_ENABLED_KEY + "="; //$NON-NLS-1$
 
 	/** the enablement default for the local instance */
@@ -96,7 +100,8 @@
 	 * 
 	 * @return true, if this instance shall report usage
 	 * 
-	 * @see #SYSPROPS_INSTANCE_ENABLED_KEY
+	 * @see #USAGE_REPORTING_ENABLED_KEY
+	 * @see #INSTANCE_USAGE_REPORTING_ENABLED_DEFAULT
 	 */
 	private boolean isInstanceReportingEnabled() {
 		return Boolean.valueOf(
Index: src/org/jboss/tools/usage/tracker/internal/UsagePluginLogger.java
===================================================================
--- src/org/jboss/tools/usage/tracker/internal/UsagePluginLogger.java	(revision 27016)
+++ src/org/jboss/tools/usage/tracker/internal/UsagePluginLogger.java	(working copy)
@@ -10,21 +10,48 @@
  ******************************************************************************/
 package org.jboss.tools.usage.tracker.internal;
 
+import org.eclipse.core.runtime.IStatus;
 import org.eclipse.core.runtime.Plugin;
-import org.jboss.tools.common.log.PluginLogger;
-import org.jboss.tools.usage.util.LoggingUtils;
+import org.eclipse.core.runtime.Status;
 
 /**
  * @author Andre Dietisheim
- *
  */
-public class UsagePluginLogger extends PluginLogger {
+public class UsagePluginLogger {
+
+	private Plugin plugin;
 
 	public UsagePluginLogger(Plugin plugin) {
-		super(plugin);
+		this.plugin = plugin;
+	}
+
+	public void error(String message) {
+		log(IStatus.ERROR, message);
+	}
+
+	public void debug(String message) {
+		log(IStatus.INFO, message);
+	}
+
+	private void log(int severity, String message) {
+		if (!isTracingEnabled()) {
+			return;
+		}
+
+		if (plugin != null) {
+			IStatus status = new Status(severity, plugin.getBundle().getSymbolicName(), message);
+			plugin.getLog().log(status);
+		}
 	}
 
+		
 	protected boolean isTracingEnabled() {
-		return LoggingUtils.isPluginTracingEnabled(getPlugin());
+		Plugin plugin = getPlugin();
+		return plugin != null && plugin.isDebugging();
+	}
+
+	protected Plugin getPlugin() {
+		return plugin;
 	}
+
 }
Index: src/org/jboss/tools/usage/tracker/internal/Tracker.java
===================================================================
--- src/org/jboss/tools/usage/tracker/internal/Tracker.java	(revision 27016)
+++ src/org/jboss/tools/usage/tracker/internal/Tracker.java	(working copy)
@@ -20,7 +20,6 @@
 import java.io.UnsupportedEncodingException;
 import java.text.MessageFormat;
 
-import org.jboss.tools.common.log.ILoggingAdapter;
 import org.jboss.tools.usage.http.IHttpGetRequest;
 import org.jboss.tools.usage.tracker.IFocusPoint;
 import org.jboss.tools.usage.tracker.ITracker;
@@ -37,21 +36,21 @@
 
 	private IURLBuildingStrategy urlBuildingStrategy = null;
 	private IHttpGetRequest httpRequest;
-	private ILoggingAdapter loggingAdapter;
+	private UsagePluginLogger logger;
 	
-	public Tracker(IURLBuildingStrategy urlBuildingStrategy, IHttpGetRequest httpGetRequest, ILoggingAdapter loggingAdapter) {
+	public Tracker(IURLBuildingStrategy urlBuildingStrategy, IHttpGetRequest httpGetRequest, UsagePluginLogger loggingAdapter) {
 		this.httpRequest = httpGetRequest;
-		this.loggingAdapter = loggingAdapter;
+		this.logger = loggingAdapter;
 		this.urlBuildingStrategy = urlBuildingStrategy;
 	}
 
 	public void trackSynchronously(IFocusPoint focusPoint) {
-		loggingAdapter
+		logger
 				.debug(MessageFormat.format(TrackerMessages.Tracker_Synchronous, focusPoint.getTitle()));
 		try {
 			httpRequest.request(getTrackingUrl(focusPoint));
 		} catch (Exception e) {
-			loggingAdapter.error(MessageFormat.format(TrackerMessages.Tracker_Error, e.getMessage()));
+			logger.error(MessageFormat.format(TrackerMessages.Tracker_Error, e.getMessage()));
 		}
 	}
 
@@ -60,7 +59,7 @@
 	}
 
 	public void trackAsynchronously(IFocusPoint focusPoint) {
-		loggingAdapter.debug(MessageFormat
+		logger.debug(MessageFormat
 				.format(TrackerMessages.Tracker_Asynchronous, focusPoint.getTitle()));
 		new Thread(new TrackingRunnable(focusPoint)).start();
 	}
@@ -76,7 +75,7 @@
 			try {
 				httpRequest.request(getTrackingUrl(focusPoint));
 			} catch (Exception e) {
-				loggingAdapter.error(MessageFormat.format(TrackerMessages.Tracker_Error, e.getMessage()));
+				logger.error(MessageFormat.format(TrackerMessages.Tracker_Error, e.getMessage()));
 			}
 		}
 	}
Index: src/org/jboss/tools/usage/util/LoggingUtils.java
===================================================================
--- src/org/jboss/tools/usage/util/LoggingUtils.java	(revision 27016)
+++ src/org/jboss/tools/usage/util/LoggingUtils.java	(working copy)
@@ -1,31 +0,0 @@
-/*******************************************************************************
- * Copyright (c) 2010 Red Hat, Inc.
- * Distributed under license by Red Hat, Inc. All rights reserved.
- * This program is made available under the terms of the
- * Eclipse Public License v1.0 which accompanies this distribution,
- * and is available at http://www.eclipse.org/legal/epl-v10.html
- *
- * Contributors:
- *     Red Hat, Inc. - initial API and implementation
- ******************************************************************************/
-package org.jboss.tools.usage.util;
-
-import org.eclipse.core.runtime.IStatus;
-import org.eclipse.core.runtime.Plugin;
-
-/**
- * @author Andre Dietisheim
- */
-public class LoggingUtils {
-
-	public static boolean isPluginTracingEnabled(Plugin plugin) {
-		return plugin != null && plugin.isDebugging();
-	}
-
-	public static void log(IStatus status, Plugin plugin) {
-		if (status.getSeverity() == IStatus.INFO && !isPluginTracingEnabled(plugin)) {
-			return;
-		}
-		plugin.getLog().log(status);
-	}
-}