Index: core/src/main/java/org/jboss/ejb3/stateful/EJB3XPCResolver.java
===================================================================
--- core/src/main/java/org/jboss/ejb3/stateful/EJB3XPCResolver.java	(revision 110054)
+++ core/src/main/java/org/jboss/ejb3/stateful/EJB3XPCResolver.java	(working copy)
@@ -21,12 +21,15 @@
  */
 package org.jboss.ejb3.stateful;
 
-import java.util.List;
-
 import javax.persistence.EntityManager;
 
+import org.jboss.jpa.deployment.ManagedEntityManagerFactory;
+import org.jboss.jpa.deployment.PersistenceUnitDeployment;
+import org.jboss.jpa.spi.PersistenceUnitRegistry;
 import org.jboss.jpa.spi.XPCResolver;
 
+import java.util.List;
+
 /**
  * EJB 3 Stateful beans are the only XPC aware components at the moment.
  * 
@@ -41,17 +44,38 @@
    public EntityManager getExtendedPersistenceContext(String kernelName)
    {
       StatefulBeanContext beanContext = StatefulBeanContext.currentBean.get();
-      
-      EntityManager em;
+
       if (beanContext != null)
       {
-         List<StatefulBeanContext> beanContexts = StatefulBeanContext.currentBean.getList();
+         /**
+          * Look for XPC in current bean set.
+          * Create the XPC (EM) if not found (and save in bean context for next lookup).
+          * Propagate created XPC as required (7.6.2.1 Inheritance of Extended Persistence Context
+          */
+         EntityManager em = null;
+         List <StatefulBeanContext> beanContexts = StatefulBeanContext.currentBean.getList();
          for( StatefulBeanContext bc : beanContexts)
          {
             em = bc.getExtendedPersistenceContext(kernelName);
             if (em != null)
                return em;
          }
+
+         ManagedEntityManagerFactory factory=
+            ((PersistenceUnitDeployment) PersistenceUnitRegistry.getPersistenceUnit(kernelName)).getManagedFactory();
+         if (factory != null)
+         {
+            em = factory.createEntityManager();
+            if (em != null)
+            {
+               for( StatefulBeanContext bc : beanContexts)
+               {
+                  bc.addExtendedPersistenceContext(kernelName, em);
+               }
+            }
+         }
+
+         return em;
       }
       return null;
    }
Index: core/src/main/java/org/jboss/ejb3/EJBContainer.java
===================================================================
--- core/src/main/java/org/jboss/ejb3/EJBContainer.java	(revision 110054)
+++ core/src/main/java/org/jboss/ejb3/EJBContainer.java	(working copy)
@@ -768,7 +768,7 @@
 //         handlers.add(new EJBHandler<Environment>());
          handlers.add(new DependsHandler<Environment>());
          handlers.add(new JndiInjectHandler<Environment>());
-         handlers.add(new PersistenceContextHandler<Environment>());
+         //handlers.add(new PersistenceContextHandler<Environment>());
       }
 
       ClassLoader old = Thread.currentThread().getContextClassLoader();
Index: core/pom.xml
===================================================================
--- core/pom.xml	(revision 110054)
+++ core/pom.xml	(working copy)
@@ -753,7 +753,7 @@
     <dependency>
       <groupId>org.jboss.jpa</groupId>
       <artifactId>jboss-jpa-deployers</artifactId>
-      <version>1.0.2-alpha-1</version>
+      <version>3.0.0-SNAPSHOT</version>
       <exclusions>
         <exclusion>
           <groupId>org.jboss</groupId>
Index: timerservice-mk2/pom.xml
===================================================================
--- timerservice-mk2/pom.xml	(revision 110054)
+++ timerservice-mk2/pom.xml	(working copy)
@@ -122,7 +122,7 @@
     <dependency>
       <groupId>org.jboss.jpa</groupId>
       <artifactId>jboss-jpa-deployers</artifactId>
-      <version>1.0.0-SNAPSHOT</version>
+      <version>3.0.0-SNAPSHOT</version>
       <scope>test</scope>
       <exclusions>
         <!-- Make sure the EJB 3.0 API doesn't get in here -->
@@ -135,7 +135,7 @@
     <dependency>
       <groupId>org.jboss.jpa</groupId>
       <artifactId>jboss-jpa-mcint</artifactId>
-      <version>1.0.0-SNAPSHOT</version>
+      <version>3.0.0-SNAPSHOT</version>
       <scope>test</scope>
     </dependency>
     <dependency>
Index: profile3_1/src/it/build/pom.xml
===================================================================
--- profile3_1/src/it/build/pom.xml	(revision 110054)
+++ profile3_1/src/it/build/pom.xml	(working copy)
@@ -23,7 +23,7 @@
     <version.org.jboss.deployers>2.0.3.GA</version.org.jboss.deployers>
     <version.org.jboss_jboss-vfs>2.0.1.GA</version.org.jboss_jboss-vfs>
     <version.org.jboss.bootstrap_jboss-bootstrap>1.0.0-Beta-1</version.org.jboss.bootstrap_jboss-bootstrap>
-    <version.org.jboss.jpa_jboss-jpa-deployers>1.0.0-Beta6</version.org.jboss.jpa_jboss-jpa-deployers>
+    <version.org.jboss.jpa_jboss-jpa-deployers>3.0.0-SNAPSHOT</version.org.jboss.jpa_jboss-jpa-deployers>
     <version.org.jboss.ejb3_jboss-ejb3-deployers>1.0.1-SNAPSHOT</version.org.jboss.ejb3_jboss-ejb3-deployers>
     <version.org.jboss.ejb3_jboss-ejb3-nointerface>1.0.0-SNAPSHOT</version.org.jboss.ejb3_jboss-ejb3-nointerface>
     <version.org.jboss.ejb3_jboss-ejb3-jta-profile>0.1.0-SNAPSHOT</version.org.jboss.ejb3_jboss-ejb3-jta-profile>
Index: profile3_1/pom.xml
===================================================================
--- profile3_1/pom.xml	(revision 110054)
+++ profile3_1/pom.xml	(working copy)
@@ -24,7 +24,7 @@
     <version.org.jboss.deployers>2.0.3.GA</version.org.jboss.deployers>
     <version.org.jboss_jboss-vfs>2.0.1.GA</version.org.jboss_jboss-vfs>
     <version.org.jboss.bootstrap_jboss-bootstrap>1.0.0-Beta-1</version.org.jboss.bootstrap_jboss-bootstrap>
-    <version.org.jboss.jpa_jboss-jpa-deployers>1.0.0-Beta6</version.org.jboss.jpa_jboss-jpa-deployers>
+    <version.org.jboss.jpa_jboss-jpa-deployers>3.0.0-SNAPSHOT</version.org.jboss.jpa_jboss-jpa-deployers>
     <version.org.jboss.ejb3_jboss-ejb3-deployers>1.0.1-SNAPSHOT</version.org.jboss.ejb3_jboss-ejb3-deployers>
 
   </properties>