### Eclipse Workspace Patch 1.0
#P photoalbum
Index: ejb/src/main/resources/components.properties
===================================================================
--- ejb/src/main/resources/components.properties	(revision 21522)
+++ ejb/src/main/resources/components.properties	(working copy)
@@ -1,4 +1,4 @@
 #
 #Mon Sep 15 14:29:33 EEST 2008
-jndiPattern=photoalbum-ear-${project.version}/#{ejbName}/local
+jndiPattern=photoalbum-ear/#{ejbName}/local
 embeddedEjb=false
Index: ejb/src/main/resources-filtered/components.properties
===================================================================
--- ejb/src/main/resources-filtered/components.properties	(revision 21522)
+++ ejb/src/main/resources-filtered/components.properties	(working copy)
@@ -1,4 +1,4 @@
 #
 #Mon Sep 15 14:29:32 EEST 2008
-jndiPattern=photoalbum-ear-${project.version}/#{ejbName}/local
+jndiPattern=photoalbum-ear/#{ejbName}/local
 embeddedEjb=false
Index: readme.txt
===================================================================
--- readme.txt	(revision 21522)
+++ readme.txt	(working copy)
@@ -25,7 +25,7 @@
 
 in the current folder.
 
-When you see the BUILD SUCCESSFUL message you can deploy the application on the server. You can deploy it on the server by copying the photoalbum/sources/ear/target/photoalbum-ear-1.0-SNAPSHOT.ear file to the JBOSS_HOME/server/default/deploy folder. Then, launch the run.bat file from JBOSS_HOME/bin/ directory to start the server.
+When you see the BUILD SUCCESSFUL message you can deploy the application on the server. You can deploy it on the server by copying the photoalbum/sources/ear/target/photoalbum-ear.ear file to the JBOSS_HOME/server/default/deploy folder. Then, launch the run.bat file from JBOSS_HOME/bin/ directory to start the server.
 
 To build the project with a full set of images you need to run
 
Index: ejb/src/main/resources/META-INF/MANIFEST.MF
===================================================================
--- ejb/src/main/resources/META-INF/MANIFEST.MF	(revision 0)
+++ ejb/src/main/resources/META-INF/MANIFEST.MF	(revision 0)
@@ -0,0 +1,3 @@
+Manifest-Version: 1.0
+Class-Path: 
+
Index: web/pom.xml
===================================================================
--- web/pom.xml	(revision 21522)
+++ web/pom.xml	(working copy)
@@ -10,7 +10,7 @@
 	</parent>
 
 	<groupId>org.richfaces.examples</groupId>
-	<artifactId>${projectName}-web</artifactId>
+	<artifactId>photoalbum-web</artifactId>
 	<name>${appName} WAR module</name>
 	<packaging>war</packaging>
 	
@@ -77,6 +77,12 @@
     		<artifactId>hibernate-commons-annotations</artifactId>
     		<version>3.3.0.ga</version>
     		<scope>provided</scope>
+    		<exclusions>
+    			<exclusion>
+    				<artifactId>commons-logging</artifactId>
+    				<groupId>commons-logging</groupId>
+    			</exclusion>
+    		</exclusions>
 		</dependency> 
 		<dependency>
 			<groupId>javax.persistence</groupId>
@@ -226,6 +232,12 @@
 			<groupId>org.richfaces.ui</groupId>
 			<artifactId>richfaces-ui</artifactId>
 			<version>${richfacesVersion}</version>
+			<exclusions>
+				<exclusion>
+					<artifactId>commons-logging</artifactId>
+					<groupId>commons-logging</groupId>
+				</exclusion>
+			</exclusions>
 		</dependency>
 		<dependency>
 			<groupId>org.richfaces.framework</groupId>
@@ -241,7 +253,7 @@
 		</dependency>
 		<dependency>
 			<groupId>org.richfaces.examples</groupId>
-			<artifactId>${projectName}-ejb</artifactId>
+			<artifactId>photoalbum-ejb</artifactId>
 			<version>${project.version}</version>
 			<type>ejb</type>
 			<scope>provided</scope>
Index: web/src/main/webapp/META-INF/MANIFEST.MF
===================================================================
--- web/src/main/webapp/META-INF/MANIFEST.MF	(revision 0)
+++ web/src/main/webapp/META-INF/MANIFEST.MF	(revision 0)
@@ -0,0 +1,3 @@
+Manifest-Version: 1.0
+Class-Path: 
+
Index: web/src/main/resources/META-INF/MANIFEST.MF
===================================================================
--- web/src/main/resources/META-INF/MANIFEST.MF	(revision 21522)
+++ web/src/main/resources/META-INF/MANIFEST.MF	(working copy)
@@ -1,15 +1,3 @@
 Manifest-Version: 1.0
-Class-Path: avalon-framework-4.1.3.jar 
- commons-beanutils-1.7.0.jar 
- commons-digester-1.8.jar 
- commons-logging-1.1.jar 
- jboss-seam-debug-2.1.0.SP1.jar 
- jboss-seam-jul-2.1.0.SP1.jar 
- jboss-seam-remoting-2.1.0.SP1.jar 
- jboss-seam-ui-2.1.0.SP1.jar 
- jsf-facelets-1.1.14.jar 
- log4j-1.2.14.jar 
- logkit-1.0.1.jar 
- richfaces-impl-3.3.0-SNAPSHOT.jar 
- richfaces-ui-3.3.0-SNAPSHOT.jar
+Class-Path: 
 
Index: ejb/pom.xml
===================================================================
--- ejb/pom.xml	(revision 21522)
+++ ejb/pom.xml	(working copy)
@@ -10,7 +10,7 @@
 	</parent>
 
 	<groupId>org.richfaces.examples</groupId>
-	<artifactId>${projectName}-ejb</artifactId>
+	<artifactId>photoalbum-ejb</artifactId>
 	<name>${appName} EJB module</name>
 	<packaging>ejb</packaging>
 
Index: ejb/src/main/resources/resources-filtered/components.properties
===================================================================
--- ejb/src/main/resources/resources-filtered/components.properties	(revision 21522)
+++ ejb/src/main/resources/resources-filtered/components.properties	(working copy)
@@ -1,4 +0,0 @@
-#
-#Mon Sep 15 14:29:33 EEST 2008
-jndiPattern=photoalbum-ear-${project.version}/#{ejbName}/local
-embeddedEjb=false
Index: ear/pom.xml
===================================================================
--- ear/pom.xml	(revision 21522)
+++ ear/pom.xml	(working copy)
@@ -8,14 +8,14 @@
 	</parent>
 
 	<groupId>org.richfaces.examples</groupId>
-	<artifactId>${projectName}-ear</artifactId>
+	<artifactId>photoalbum-ear</artifactId>
 	<name>${appName} EAR module</name>
 	<packaging>ear</packaging>
 
 	<dependencies>
 		<dependency>
 			<groupId>org.richfaces.examples</groupId>
-			<artifactId>${projectName}-web</artifactId>
+			<artifactId>photoalbum-web</artifactId>
 			<version>${project.version}</version>
 			<type>war</type>
 		</dependency>
@@ -26,7 +26,7 @@
 		</dependency>
 		<dependency>
 			<groupId>org.richfaces.examples</groupId>
-			<artifactId>${projectName}-ejb</artifactId>
+			<artifactId>photoalbum-ejb</artifactId>
 			<version>${project.version}</version>
 			<type>ejb</type>
 		</dependency>
@@ -34,6 +34,7 @@
             <groupId>log4j</groupId>
             <artifactId>log4j</artifactId>
             <version>1.2.14</version>
+            <scope>provided</scope>
         </dependency>
 	<dependency>
       <groupId>org.jboss.seam</groupId>
@@ -61,7 +62,7 @@
     </dependency>
 	</dependencies>
 	<build>
-		<finalName>${projectName}-ear-${project.version}</finalName>
+		<finalName>photoalbum-ear</finalName>
 		<plugins>
 			<plugin>
 				<groupId>org.apache.maven.plugins</groupId>
@@ -81,12 +82,12 @@
 					<modules>
 						<webModule>
 							<groupId>org.richfaces.examples</groupId>
-							<artifactId>${projectName}-web</artifactId>
-							<contextRoot>/${projectName}</contextRoot>
+							<artifactId>photoalbum-web</artifactId>
+							<contextRoot>/photoalbum-web</contextRoot>
 						</webModule>
 						<ejbModule>
 							<groupId>org.richfaces.examples</groupId>
-							<artifactId>${projectName}-ejb</artifactId>
+							<artifactId>photoalbum-ejb</artifactId>
 						</ejbModule>
 						<ejbModule>
 							<groupId>org.jboss.seam</groupId>